## mmseqs2 11-e1a1c+ds

=== debian/changelog ===
mmseqs2 (11-e1a1c+ds-3) unstable; urgency=medium

  * Team upload.

  [ Alberto Garcia ]
  * debian/patches/fix-ftbfs-gcc10.patch:
    - Fix FTBFS with GCC 10 (Closes: #957552).

  [ Michael R. Crusoe ]
  * Accept the patch from Alberto, thanks!
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 04 May 2020 17:30:26 +0200

mmseqs2 (11-e1a1c+ds-2) unstable; urgency=medium

  * Install binaries only in the mmseqs2 binary package, not also the
    mmseqs2-examples binary package
  * Report the Debian package version instead of "GITDIR-NOTFOUND"
  * Small tweak to simde patch
  * Use a newer libsimde-dev that fixes a bug found by this package

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 24 Apr 2020 22:21:06 +0200

mmseqs2 (11-e1a1c+ds-1) unstable; urgency=medium

  * Team upload.
  * Enable building on non-X86 and with less than SSE4.1 using
    libsimde-dev
  * Mark mmseqs2-examples as Multi-Arch: foreign
  * Clean up debian/copyright
  * debian/upstream/metadata: add GitHub related fields

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 23 Apr 2020 22:39:06 +0200

=== debian/control ===
Source: mmseqs2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12)
Build-Depends-Arch: cmake,
                    libgzstream-dev,
                    libzstd-dev,
                    zlib1g-dev,
                    libbz2-dev,
                    libsimde-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/mmseqs2
Vcs-Git: https://salsa.debian.org/med-team/mmseqs2.git
Homepage: https://github.com/soedinglab/MMseqs2
Rules-Requires-Root: no

Package: mmseqs2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Built-Using: ${simde:Built-Using}
Description: ultra fast and sensitive protein search and clustering
 MMseqs2 (Many-against-Many sequence searching) is a software suite to
 search and cluster huge proteins/nucleotide sequence sets. MMseqs2 is
 open source GPL-licensed software implemented in C++ for Linux, MacOS,
 and (as beta version, via cygwin) Windows. The software is designed to
 run on multiple cores and servers and exhibits very good scalability.
 MMseqs2 can run 10000 times faster than BLAST. At 100 times its speed it
 achieves almost the same sensitivity. It can perform profile searches
 with the same sensitivity as PSI-BLAST at over 400 times its speed.

Package: mmseqs2-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: mmseqs2
Description: optional resources for the mmseqs2 package
 MMseqs2 (Many-against-Many sequence searching) is a software suite to
 search and cluster huge proteins/nucleotide sequence sets. MMseqs2 is
 open source GPL-licensed software implemented in C++ for Linux, MacOS,
 and (as beta version, via cygwim) Windows. The software is designed to
 run on multiple cores and servers and exhibits very good scalability.
 MMseqs2 can run 10000 times faster than BLAST. At 100 times its speed it
 achieves almost the same sensitivity. It can perform profile searches
 with the same sensitivity as PSI-BLAST at over 400 times its speed.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

binprefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr/bin
libexecdir=$(prefix)/lib/$(DEB_SOURCE)

%:
	dh $@

override_dh_auto_configure-arch:
ifeq (amd64,$(DEB_HOST_ARCH))
	for SIMD in avx2 avx sse4.1 ssse3 sse3 sse2 ; do \
	        export CXXFLAGS="$(CXXFLAGS) -m$${SIMD}" && export CFLAGS="$(CFLAGS) -m$${SIMD}" && \
	        dh_auto_configure --builddirectory build_$${SIMD} -- -DEXE_SUFFIX=-$${SIMD} -DVERSION_OVERRIDE=$(DEB_VERSION) ; \
	done
else ifeq (i386,$(DEB_HOST_ARCH))
	for SIMD in ssse3 sse3 sse2 ; do \
	        export CXXFLAGS="$(CXXFLAGS) -m$${SIMD}" && export CFLAGS="$(CFLAGS) -m$${SIMD}" && \
	        dh_auto_configure --builddirectory build_$${SIMD} -- -DEXE_SUFFIX=-$${SIMD} -DVERSION_OVERRIDE=$(DEB_VERSION) ; \
	done
	export CXXFLAGS="$(CXXFLAGS)" && export CFLAGS="$(CFLAGS)" && \
		dh_auto_configure --builddirectory build_plain -- -DEXE_SUFFIX=-plain -DVERSION_OVERRIDE=$(DEB_VERSION)
else
	dh_auto_configure -- -DVERSION_OVERRIDE=$(DEB_VERSION)
endif

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
ifeq (amd64,$(DEB_HOST_ARCH))
	mkdir -p $(binprefix)
	for SIMD in avx2 avx sse4.1 ssse3 sse3 sse2 ; do \
		dh_auto_build --builddirectory build_$${SIMD} ; \
	done
else ifeq (i386,$(DEB_HOST_ARCH))
	mkdir -p $(binprefix)
	for SIMD in ssse3 sse3 sse2 ; do \
	        dh_auto_build --builddirectory build_$${SIMD} ; \
	done
	dh_auto_build --builddirectory build_plain
else
	dh_auto_build
endif

override_dh_auto_build-indep:

override_dh_auto_install-arch:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_install -pmmseqs2 debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	for SIMD in avx2 avx sse4.1 ssse3 sse3 sse2 ; do \
		dh_auto_install --builddirectory build_$${SIMD} ; \
	done
	dh_install -pmmseqs2 usr/bin/mmseqs-* usr/bin/
	cd $(binprefix) \
		&& for prog in mmseqs ; do \
		ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else ifeq (i386,$(DEB_HOST_ARCH))
	dh_install -pmmseqs2 debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	for SIMD in ssse3 sse3 sse2 ; do \
	        dh_auto_install --builddirectory build_$${SIMD} ; \
	done
	dh_auto_install --builddirectory build_plain
	dh_install -pmmseqs2 usr/bin/mmseqs-* usr/bin/
	cd $(binprefix) \
		&& for prog in mmseqs ; do \
		ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else
	dh_auto_install
	dh_install -pmmseqs2 usr/bin/mmseqs usr/bin/
endif

override_dh_auto_install-indep:

override_dh_auto_clean:
	dh_auto_clean
	rm -Rf build-*

override_dh_install-arch:
	dh_install --arch
	mkdir -p debian/mmseqs2/usr/lib/mmseqs2/test
	cp src/test/*.index debian/mmseqs2/usr/lib/mmseqs2/test/
	cp src/test/dataGap debian/mmseqs2/usr/lib/mmseqs2/test/
	cp src/test/dataLinear debian/mmseqs2/usr/lib/mmseqs2/test/
	#cp -r obj-$(DEB_HOST_MULTIARCH)/src/test debian/mmseqs2/usr/lib/mmseqs2/

	# We also remove unneeded files & folders like CMake
	rm -rf debian/mmseqs2/usr/lib/mmseqs2/test/CMakeFiles \
		debian/mmseqs2/usr/lib/mmseqs2/test/*.cmake \
		debian/mmseqs2/usr/lib/mmseqs2/test/Makefile

override_dh_install-indep:
	dh_install --indep

	# We also remove unneeded files & folders like CMake
	rm -rf debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/*.lib \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiag.out \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiagTargetCov.out

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

## mmseqs2 12

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
project(MMseqs CXX C)
message("-- Source Directory: ${CMAKE_CURRENT_SOURCE_DIR}")
message("-- Project Directory: ${PROJECT_SOURCE_DIR}")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(FRAMEWORK_ONLY 0 CACHE BOOL "Framework mode (don't create mmseqs executable)")
set(HAVE_SANITIZER 0 CACHE BOOL "Have sanitizers")
set(INSTALL_UTIL 1 CACHE BOOL "Install utility scripts")
set(VERSION_OVERRIDE "" CACHE STRING "Override version string in help and usage messages")
set(DISABLE_IPS4O 0 CACHE BOOL "Disabling IPS4O sorting library requiring 128-bit compare exchange operations")
set(HAVE_AVX2 0 CACHE BOOL "Have CPU with AVX2")
set(HAVE_SSE4_1 0 CACHE BOOL "Have CPU with SSE4.1")
set(HAVE_SSE2 0 CACHE BOOL "Have CPU with SSE2")
set(HAVE_POWER9 0 CACHE BOOL "Have POWER9 CPU")
set(HAVE_POWER8 0 CACHE BOOL "Have POWER8 CPU")
set(HAVE_ARM8 0 CACHE BOOL "Have ARMv8 CPU")
set(NATIVE_ARCH 1 CACHE BOOL "Assume native architecture for SIMD. Use one of the HAVE_* options or set CMAKE_CXX_FLAGS to the appropriate flags if you disable this.")

if (HAVE_SANITIZER)
    include(FindUBSan)
    include(FindASan)
    include(FindMSan)
    include(FindTSan)
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif ()

# find compiler
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message("-- Compiler is clang(++)")
    set(CMAKE_COMPILER_IS_CLANG 1)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    message("-- Compiler is GNU ")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9.0")
        message(FATAL_ERROR "Insufficient gcc version")
    endif ()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    message("-- Compiler is icc(++)")
    set(CMAKE_COMPILER_IS_ICC 1)
endif ()

# see https://wiki.debian.org/ArchitectureSpecificsMemo for char signedness

set(MMSEQS_CXX_FLAGS "-std=c++1y -fsigned-char")
if (CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*|aarch64.*|AARCH64.*)")
    set(ARM 1)
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "PPC64*|ppc64*|powerpc64*")
    set(PPC64 1)
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "amd64|AMD64")
    set(X64 1)
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "x86|X86")
    set(X86 1)
else ()
    message(WARNING "CPU without native SIMD instructions. Performance will be bad.")
endif ()

# SIMD instruction sets support
set(MMSEQS_ARCH "")
if (HAVE_AVX2)
    if (CMAKE_COMPILER_IS_CLANG)
        set(MMSEQS_ARCH "${MMSEQS_ARCH} -mavx2 -mcx16")
    else ()
        set(MMSEQS_ARCH "${MMSEQS_ARCH} -mavx2 -mcx16 -Wa,-q")
    endif ()
elseif (HAVE_SSE4_1)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -msse4.1 -mcx16")
elseif (HAVE_SSE2)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -msse2")
    set(DISABLE_IPS4O 1)
elseif (HAVE_POWER9)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -mcpu=power9 -mvsx")
elseif (HAVE_POWER8)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -mcpu=power8 -mvsx")
elseif (HAVE_ARM8)
    set(MMSEQS_ARCH "${MMSEQS_ARCH} -march=armv8-a+simd")
endif ()

if (NATIVE_ARCH AND (MMSEQS_ARCH STREQUAL ""))
    if (EMSCRIPTEN)
        set(MMSEQS_ARCH "-msimd128 -s WASM=1 -s ASSERTIONS=1")
    elseif (X86 OR X64)
        include(CheckSSEFeatures)
        if (NOT HAVE_SSE4_1_EXTENSIONS)
            if (NOT HAVE_SSE2_EXTENSIONS)
                message(FATAL_ERROR "At least SSE2 is needed to compile")
            endif ()
            message(WARNING "At least SSE4.1 is needed for best performance")
        endif ()
        if (PPC64)
            set(MMSEQS_ARCH "-mcpu=native")
        else ()
            # clang has a problem with march=native on travis
            if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.0.0")
                set(MMSEQS_ARCH "${SSE_FLAGS}")
            else()
                set(MMSEQS_ARCH "-march=native")
            endif()
        endif ()
    else ()
        if (PPC64)
            set(MMSEQS_ARCH "-mcpu=native")
        else ()
            set(MMSEQS_ARCH "-march=native")
        endif ()
    endif ()
endif ()

if (NOT (MMSEQS_ARCH STREQUAL ""))
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} ${MMSEQS_ARCH}")
endif ()

if (CYGWIN OR ARM OR PPC64)
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D_GNU_SOURCE=1")
endif ()

# Compiler-specific features
if (CMAKE_COMPILER_IS_CLANG AND (NOT EMSCRIPTEN))
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -stdlib=libc++")
endif ()

if (CMAKE_COMPILER_IS_ICC)
    # default -fp-model results in inconsistent results in profile search
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -fp-model precise")
endif ()

# Apple specific features
if (APPLE)
    # macOS SDK started using _Atomic (in ucred.h) which g++ does not support
    # __APPLE_API_STRICT_CONFORMANCE makes sysctl.h not include apis like ucred.h
    # See: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=89864
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D__APPLE_API_STRICT_CONFORMANCE")
endif ()

if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D_WITH_GETLINE")
endif ()

if (CYGWIN)
    # default cygwin allocator (dlmalloc) locks on every allocation and destroys MT performance
    add_subdirectory(lib/nedmalloc)
    # IPS4O seems to deadlock on cygwin
    set(DISABLE_IPS4O 1)
endif()

if ((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0.0")
        OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.1.0"))
    # clang before v5 throws compile errors on ips4o
    set(DISABLE_IPS4O 1)
endif ()

if (PPC64)
    # FIXME: investigate why on ppc the regression seems to fail randomly
    set(DISABLE_IPS4O 1)
endif ()

# zstd
# We use ZSTD_findDecompressedSize which is only available with ZSTD_STATIC_LINKING_ONLY
# Thus we cannot use a system provided libzstd
set(ZSTD_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd")
set(CMAKE_INSTALL_LIBDIR bin)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd/build/cmake/CMakeModules")
option(ZSTD_LEGACY_SUPPORT "LEGACY SUPPORT" OFF)
option(ZSTD_BUILD_STATIC "BUILD STATIC LIBRARIES" ON)
option(ZSTD_BUILD_SHARED "BUILD SHARED LIBRARIES" OFF)
option(ZSTD_MULTITHREAD_SUPPORT "MULTITHREADING SUPPORT" OFF)
option(ZSTD_BUILD_PROGRAMS "BUILD PROGRAMS" OFF)
option(ZSTD_BUILD_CONTRIB "BUILD CONTRIB" OFF)
option(ZSTD_BUILD_TESTS "BUILD TESTS" OFF)
include_directories(lib/zstd/lib)
add_subdirectory(lib/zstd/build/cmake/lib EXCLUDE_FROM_ALL)

# tinyexpr
include_directories(lib/tinyexpr)
add_subdirectory(lib/tinyexpr EXCLUDE_FROM_ALL)

# microtar
include_directories(lib/microtar)
add_subdirectory(lib/microtar)

# simde
include_directories(lib/simde)

include_directories(lib)
include_directories(lib/simd)
include_directories(lib/gzstream)
include_directories(lib/alp)
include_directories(lib/cacode)
include_directories(lib/ksw2)
include_directories(lib/xxhash)
if (NOT DISABLE_IPS4O)
    include_directories(lib/ips4o)
endif ()

add_subdirectory(lib/cacode)
add_subdirectory(lib/alp)
add_subdirectory(lib/ksw2)
add_subdirectory(data)
add_subdirectory(src)
if (NOT FRAMEWORK_ONLY AND INSTALL_UTIL)
    add_subdirectory(util)
endif ()

=== src/CMakeLists.txt ===
set(HAVE_MPI 0 CACHE BOOL "Have MPI")
set(HAVE_TESTS 0 CACHE BOOL "Have Tests")
set(HAVE_SHELLCHECK 1 CACHE BOOL "Have ShellCheck")
set(HAVE_GPROF 0 CACHE BOOL "Have GPROF Profiler")
set(ENABLE_WERROR 0 CACHE BOOL "Enable Warnings as Errors")
#set(DISABLE_LTO 0 CACHE BOOL "Disable link-time optimization in non-debug builds")
set(REQUIRE_OPENMP 1 CACHE BOOL "Require availability of OpenMP")

include(AppendTargetProperty)

add_subdirectory(alignment)
add_subdirectory(clustering)
add_subdirectory(commons)
add_subdirectory(linclust)
add_subdirectory(multihit)
add_subdirectory(prefiltering)
add_subdirectory(taxonomy)
add_subdirectory(util)
add_subdirectory(workflow)

add_library(mmseqs-framework
        $<TARGET_OBJECTS:alp>
        $<TARGET_OBJECTS:ksw2>
        $<TARGET_OBJECTS:cacode>
        ${alignment_header_files}
        ${alignment_source_files}
        ${clustering_header_files}
        ${clustering_source_files}
        ${commons_header_files}
        ${commons_source_files}
        ${prefiltering_header_files}
        ${prefiltering_source_files}
        ${multihit_header_files}
        ${multihit_source_files}
        ${taxonomy_header_files}
        ${taxonomy_source_files}
        ${linclust_source_files}
        ${util_header_files}
        ${util_source_files}
        ${workflow_source_files}
        CommandDeclarations.h
        MMseqsBase.cpp
        )

target_include_directories(mmseqs-framework PUBLIC ${CMAKE_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC ${PROJECT_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC alignment)
target_include_directories(mmseqs-framework PUBLIC clustering)
target_include_directories(mmseqs-framework PUBLIC commons)
target_include_directories(mmseqs-framework PUBLIC multihit)
target_include_directories(mmseqs-framework PUBLIC prefiltering)
target_include_directories(mmseqs-framework PUBLIC linclust)
target_include_directories(mmseqs-framework PUBLIC taxonomy)
target_include_directories(mmseqs-framework PUBLIC util)
target_include_directories(mmseqs-framework PUBLIC .)

add_dependencies(mmseqs-framework generated)

#if (NOT DISABLE_LTO)
#    string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
#    if (uppercase_CMAKE_BUILD_TYPE MATCHES "^(RELEASE|RELWITHDEBINFO|MINSIZEREL)$")
#        cmake_policy(SET CMP0069 NEW)
#        include(CheckIPOSupported)
#        check_ipo_supported(RESULT IPO_SUPPORTED)
#        if (IPO_SUPPORTED)
#            set_property(TARGET mmseqs-framework PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
#        endif ()
#    endif ()
#endif ()

append_target_property(mmseqs-framework COMPILE_FLAGS ${MMSEQS_CXX_FLAGS} -pedantic -Wall -Wextra -Wdisabled-optimization)
append_target_property(mmseqs-framework LINK_FLAGS ${MMSEQS_CXX_FLAGS} -pedantic -Wall -Wextra -Wdisabled-optimization)
if (NOT EMSCRIPTEN)
    append_target_property(mmseqs-framework COMPILE_FLAGS -fno-exceptions)
    append_target_property(mmseqs-framework LINK_FLAGS -fno-exceptions)
endif()

if (ENABLE_WERROR)
    append_target_property(mmseqs-framework COMPILE_FLAGS -Werror)
    append_target_property(mmseqs-framework LINK_FLAGS -Werror)
endif()

# needed for concat.h
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>

        int main() {
          FILE* tmpf = tmpfile();
          int input_desc = fileno(tmpf);
          int test = posix_fadvise(input_desc, 0, 0, POSIX_FADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_FADVISE)
if (HAVE_POSIX_FADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_FADVISE=1)
endif ()

check_cxx_source_compiles("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>
        #include <sys/mman.h>

        int main() {
          FILE* tmpf = tmpfile();
          void *tmp = mmap(NULL, 32, PROT_READ, MAP_SHARED, fileno(tmpf), 0);
          int test = posix_madvise(tmp, 32, POSIX_MADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_MADVISE)
if (HAVE_POSIX_MADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_MADVISE=1)
endif ()

if (NOT DISABLE_IPS4O)
    find_package(Atomic)
    if (ATOMIC_FOUND)
        target_link_libraries(mmseqs-framework ${ATOMIC_LIBRARIES})
        target_compile_definitions(mmseqs-framework PUBLIC -DENABLE_IPS4O=1)
        message("-- IPS4O sorting works")
    else ()
        message("-- OMPTL sorting fallback")
    endif ()
else ()
    message("-- OMPTL sorting fallback")
endif ()

target_link_libraries(mmseqs-framework tinyexpr libzstd_static microtar)
if (CYGWIN)
    target_link_libraries(mmseqs-framework nedmalloc)
endif ()

if (EMSCRIPTEN)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_ZLIB=1 -DHAVE_BZLIB=1)
    append_target_property(mmseqs-framework COMPILE_FLAGS -s USE_ZLIB=1 -s USE_BZIP2=1)
    append_target_property(mmseqs-framework LINK_FLAGS -s USE_ZLIB=1 -s USE_BZIP2=1)
else ()
find_package(ZLIB QUIET)
if (ZLIB_FOUND)
    message("-- Found ZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lz)
    set(CMAKE_REQUIRED_INCLUDES ${ZLIB_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${ZLIB_LIBRARIES})
    check_cxx_source_compiles("
        #include <zlib.h>
        int main() { gzFile file; return 0; }"
        HAVE_ZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_ZLIB_CHECK)
        message("-- ZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${ZLIB_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_ZLIB=1)
        target_link_libraries(mmseqs-framework ${ZLIB_LIBRARIES})
    else ()
        message("-- ZLIB does not work")
    endif()
else ()
    message("-- Could not find ZLIB")
endif ()

find_package(BZip2 QUIET)
if (BZIP2_FOUND)
    message("-- Found BZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lbz2)
    set(CMAKE_REQUIRED_INCLUDES ${BZIP_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${BZIP2_LIBRARIES})
    check_cxx_source_compiles("
        #include <bzlib.h>
        int main() { bz_stream stream; return 0; }"
        HAVE_BZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_BZLIB_CHECK)
        message("-- BZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${BZIP_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_BZLIB=1)
        target_link_libraries(mmseqs-framework ${BZIP2_LIBRARIES})
    else ()
        message("-- BZLIB does not work")
    endif()
else ()
    message("-- Could not find BZLIB")
endif ()
endif ()

# MPI
if (HAVE_MPI)
    find_package(MPI REQUIRED)
    if (MPI_FOUND)
        message("-- Found MPI")
        target_include_directories(mmseqs-framework PUBLIC ${MPI_INCLUDE_PATH})
        #Hack (OMPI_SKIP_MPICXX=1): https://github.com/open-mpi/ompi/issues/5157#issuecomment-388495496
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_MPI=1 -DOMPI_SKIP_MPICXX=1)
        target_link_libraries(mmseqs-framework ${MPI_LIBRARIES})
        append_target_property(mmseqs-framework COMPILE_FLAGS ${MPI_COMPILE_FLAGS})
        append_target_property(mmseqs-framework LINK_FLAGS ${MPI_LINK_FLAGS})
    endif ()
endif ()


find_package(OpenMP QUIET)
if (OPENMP_FOUND)
    message("-- Found OpenMP")
    target_compile_definitions(mmseqs-framework PUBLIC -DOPENMP=1)
    # For GCC we dont want to do this since it breaks macOS static builds
    # It will link libgomp.a internally (through -fopenmp I guess)
    # and also link libgomp.dylib thus breaking static builds
    if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
    endif()
    append_target_property(mmseqs-framework COMPILE_FLAGS ${OpenMP_CXX_FLAGS})
    append_target_property(mmseqs-framework LINK_FLAGS ${OpenMP_CXX_FLAGS})
elseif (REQUIRE_OPENMP)
    message(FATAL_ERROR "-- Could not find OpenMP. Skip check with -DREQUIRE_OPENMP=0.")
endif ()

if (HAVE_GPROF)
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-pg GPROF_FOUND)
    if (GPROF_FOUND)
        append_target_property(mmseqs-framework COMPILE_FLAGS -pg)
        append_target_property(mmseqs-framework LINK_FLAGS -pg)
    else ()
        message(FATAL_ERROR "-- Could not find GPROF")
    endif ()
endif ()

if (NOT FRAMEWORK_ONLY)
    include(MMseqsSetupDerivedTarget)
    add_subdirectory(version)
    set(mmseqs_source_files mmseqs.cpp)

    add_executable(mmseqs${EXE_SUFFIX} ${mmseqs_source_files})
    mmseqs_setup_derived_target(mmseqs${EXE_SUFFIX})
    target_link_libraries(mmseqs${EXE_SUFFIX} version)
    install(TARGETS mmseqs${EXE_SUFFIX} DESTINATION bin)

    if (HAVE_TESTS)
        add_subdirectory(test)
    endif ()
endif ()

=== data/workflow/CMakeLists.txt ===
set(GENERATED_WORKFLOWS
        workflow/easysearch.sh
        workflow/easycluster.sh
        workflow/easytaxonomy.sh
        workflow/easyrbh.sh
        workflow/blastp.sh
        workflow/blastpgp.sh
        workflow/map.sh
        workflow/rbh.sh
        workflow/linclust.sh
        workflow/clustering.sh
        workflow/cascaded_clustering.sh
        workflow/update_clustering.sh
        workflow/searchtargetprofile.sh
        workflow/createindex.sh
        workflow/createtaxdb.sh
        workflow/translated_search.sh
        workflow/taxonomy.sh
        workflow/taxpercontig.sh
        workflow/multihitdb.sh
        workflow/multihitsearch.sh
        workflow/enrich.sh
        workflow/blastn.sh
        workflow/searchslicedtargetprofile.sh
        workflow/linsearch.sh
        workflow/databases.sh
        workflow/nucleotide_clustering.sh
        PARENT_SCOPE
        )

=== lib/cacode/CMakeLists.txt ===
add_library(cacode OBJECT
        lambda_calculator.cpp
        lambda_calculator.h
        lubksb.cpp
        ludcmp.cpp
        nrutil.cpp
        nrutil.h
        )
set_target_properties(cacode PROPERTIES COMPILE_FLAGS "${MMSEQS_CXX_FLAGS}" LINK_FLAGS "${MMSEQS_CXX_FLAGS}")

=== lib/microtar/CMakeLists.txt ===
add_library(microtar microtar.h microtar.c)

=== lib/tinyexpr/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)

project(tinyexpr)

option(TE_POW_FROM_RIGHT "Evaluate exponents from right to left." OFF)
option(TE_NAT_LOG "Define the log function as natural logarithm." OFF)
option(build_tinyexpr_test "Build TinyExpr tests." OFF)
option(build_tinyexpr_test_pr "Build TinyExpr tests PR." OFF)
option(build_tinyexpr_bench "Build TinyExpr benchmark." OFF)
option(build_tinyexpr_example "Build TinyExpr example." OFF)
option(build_tinyexpr_example2 "Build TinyExpr example 2." OFF)
option(build_tinyexpr_example3 "Build TinyExpr example 3." OFF)

find_library(MATH_LIB m)
if(NOT MATH_LIB)
    set(MATH_LIB "")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ansi -Wall -Wshadow -fPIC -O3")

set(SOURCE_FILES
        tinyexpr.c
        tinyexpr.h
        )

add_library(tinyexpr STATIC ${SOURCE_FILES})
if (TE_POW_FROM_RIGHT)
    target_compile_definitions(tinyexpr PRIVATE TE_POW_FROM_RIGHT)
endif()
if (TE_NAT_LOG)
    target_compile_definitions(tinyexpr PRIVATE TE_NAT_LOG)
endif()
target_link_libraries(tinyexpr ${MATH_LIB})
install(TARGETS tinyexpr ARCHIVE DESTINATION lib)
install(FILES tinyexpr.h DESTINATION include COMPONENT Devel)

if (build_tinyexpr_test)
    add_executable(tinyexpr_test test.c tinyexpr.c)
    target_link_libraries(tinyexpr_test ${MATH_LIB})
endif()

if (build_tinyexpr_test_pr)
    add_executable(tinyexpr_test_pr test.c tinyexpr.c)
    target_compile_definitions(tinyexpr_test_pr PRIVATE TE_POW_FROM_RIGHT TE_NAT_LOG)
    target_link_libraries(tinyexpr_test_pr ${MATH_LIB})
endif()

if (build_tinyexpr_bench)
    add_executable(tinyexpr_benchmark benchmark.c tinyexpr.c)
    target_link_libraries(tinyexpr_benchmark ${MATH_LIB})
endif()

if (build_tinyexpr_example)
    add_executable(tinyexpr_example example.c tinyexpr.c)
    target_link_libraries(tinyexpr_example ${MATH_LIB})
endif()

if (build_tinyexpr_example2)
    add_executable(tinyexpr_example2 example2.c tinyexpr.c)
    target_link_libraries(tinyexpr_example2 ${MATH_LIB})
endif()

if (build_tinyexpr_example3)
    add_executable(tinyexpr_example3 example3.c tinyexpr.c)
    target_link_libraries(tinyexpr_example3 ${MATH_LIB})
endif()

=== lib/tinyexpr/Makefile ===
CCFLAGS = -ansi -Wall -Wshadow -O2
LFLAGS = -lm

.PHONY = all clean

all: test test_pr bench example example2 example3


test: test.c tinyexpr.c
	$(CC) $(CCFLAGS) -o $@ $^ $(LFLAGS)
	./$@

test_pr: test.c tinyexpr.c
	$(CC) $(CCFLAGS) -DTE_POW_FROM_RIGHT -DTE_NAT_LOG -o $@ $^ $(LFLAGS)
	./$@

bench: benchmark.o tinyexpr.o
	$(CC) $(CCFLAGS) -o $@ $^ $(LFLAGS)

example: example.o tinyexpr.o
	$(CC) $(CCFLAGS) -o $@ $^ $(LFLAGS)

example2: example2.o tinyexpr.o
	$(CC) $(CCFLAGS) -o $@ $^ $(LFLAGS)

example3: example3.o tinyexpr.o
	$(CC) $(CCFLAGS) -o $@ $^ $(LFLAGS)

.c.o:
	$(CC) -c $(CCFLAGS) $< -o $@

clean:
	rm -f *.o *.exe example example2 example3 bench test_pr test

=== src/commons/CMakeLists.txt ===
set(commons_header_files
        commons/A3MReader.h
        commons/AminoAcidLookupTables.h
        commons/BacktraceTranslator.h
        commons/ByteParser.h
        commons/Command.h
        commons/CommandCaller.h
        commons/Concat.h
        commons/DBConcat.h
        commons/DBReader.h
        commons/DBWriter.h
        commons/IntervalArray.h
        commons/Debug.h
        commons/Domain.h
        commons/ExpressionParser.h
        commons/FileUtil.h
        commons/HeaderSummarizer.h
        commons/IndexReader.h
        commons/itoa.h
        commons/KSeqBufferReader.h
        commons/KSeqWrapper.h
        commons/MathUtil.h
        commons/MemoryMapped.h
        commons/MemoryTracker.h
        commons/MMseqsMPI.h
        commons/MultiParam.h
        commons/NucleotideMatrix.h
        commons/Orf.h
        commons/ProfileStates.h
        commons/LibraryReader.h
        commons/Parameters.h
        commons/PatternCompiler.h
        commons/ScoreMatrix.h
        commons/Sequence.h
        commons/SubstitutionMatrix.h
        commons/SubstitutionMatrixProfileStates.h
        commons/tantan.h
        commons/TranslateNucl.h
        commons/Timer.h
        commons/UniprotKB.h
        commons/Util.h
        PARENT_SCOPE
        )

set(commons_source_files
        commons/A3MReader.cpp
        commons/Application.cpp
        commons/BaseMatrix.cpp
        commons/Command.cpp
        commons/CommandCaller.cpp
        commons/DBConcat.cpp
        commons/DBReader.cpp
        commons/DBWriter.cpp
        commons/Debug.cpp
        commons/ExpressionParser.cpp
        commons/FileUtil.cpp
        commons/HeaderSummarizer.cpp
        commons/KSeqWrapper.cpp
        commons/MemoryMapped.cpp
        commons/MemoryTracker.cpp
        commons/MMseqsMPI.cpp
        commons/MultiParam.cpp
        commons/NucleotideMatrix.cpp
        commons/Orf.cpp
        commons/Parameters.cpp
        commons/ProfileStates.cpp
        commons/LibraryReader.cpp
        commons/Sequence.cpp
        commons/SubstitutionMatrix.cpp
        commons/tantan.cpp
        commons/UniprotKB.cpp
        commons/Util.cpp
        PARENT_SCOPE
        )

=== src/taxonomy/CMakeLists.txt ===
set(taxonomy_header_files
        taxonomy/NcbiTaxonomy.h
        PARENT_SCOPE
        )


set(taxonomy_source_files
        taxonomy/lca.cpp
        taxonomy/addtaxonomy.cpp
        taxonomy/NcbiTaxonomy.cpp
        taxonomy/filtertaxdb.cpp
        taxonomy/filtertaxseqdb.cpp
        taxonomy/aggregatetax.cpp
        taxonomy/createtaxdb.cpp
        taxonomy/taxonomyreport.cpp
        taxonomy/TaxonomyExpression.h
        PARENT_SCOPE
        )

=== src/util/CMakeLists.txt ===
set(util_source_files
        util/alignall.cpp
        util/alignbykmer.cpp
        util/apply.cpp
        util/clusthash.cpp
        util/compress.cpp
        util/convert2fasta.cpp
        util/convertalignments.cpp
        util/convertca3m.cpp
        util/convertkb.cpp
        util/convertmsa.cpp
        util/convertprofiledb.cpp
        util/createdb.cpp
        util/dbtype.cpp
        util/indexdb.cpp
        util/offsetalignment.cpp
        util/createseqfiledb.cpp
        util/createsubdb.cpp
        util/view.cpp
        util/createtsv.cpp
        util/diffseqdbs.cpp
        util/expandaln.cpp
        util/extractalignedregion.cpp
        util/extractdomains.cpp
        util/extractorfs.cpp
        util/orftocontig.cpp
        util/touchdb.cpp
        util/filterdb.cpp
        util/gff2db.cpp
        util/renamedbkeys.cpp
        util/masksequence.cpp
        util/maskbygff.cpp
        util/mergeclusters.cpp
        util/mergeresultsbyset.cpp
        util/mergedbs.cpp
        util/msa2profile.cpp
        util/msa2result.cpp
        util/mvdb.cpp
        util/countkmer.cpp
        util/prefixid.cpp
        util/profile2cs.cpp
        util/profile2pssm.cpp
        util/profile2seq.cpp
        util/result2dnamsa.cpp
        util/result2flat.cpp
        util/result2msa.cpp
        util/result2rbh.cpp
        util/result2profile.cpp
        util/result2pp.cpp
        util/result2repseq.cpp
        util/result2stats.cpp
        util/reverseseq.cpp
        util/rmdb.cpp
        util/extractframes.cpp
        util/sortresult.cpp
        util/splitdb.cpp
        util/splitsequence.cpp
        util/subtractdbs.cpp
        util/summarizealis.cpp
        util/summarizeheaders.cpp
        util/summarizeresult.cpp
        util/summarizetabs.cpp
        util/swapresults.cpp
        util/transitivealign.cpp
        util/translatenucs.cpp
        util/translateaa.cpp
        util/tsv2db.cpp
        util/tar2db.cpp
        util/proteinaln2nucl.cpp
        util/versionstring.cpp
        util/diskspaceavail.cpp
        PARENT_SCOPE
        )

=== src/workflow/CMakeLists.txt ===
set(workflow_source_files
        workflow/Cluster.cpp
        workflow/ClusterUpdate.cpp
        workflow/Databases.cpp
        workflow/Linclust.cpp
        workflow/EasySearch.cpp
        workflow/EasyRbh.cpp
        workflow/EasyCluster.cpp
        workflow/EasyLinclust.cpp
        workflow/Enrich.cpp
        workflow/Linsearch.cpp
        workflow/Map.cpp
        workflow/Rbh.cpp
        workflow/Search.cpp
        workflow/Taxonomy.cpp
        workflow/TaxPerContig.cpp
        workflow/EasyTaxonomy.cpp
        workflow/CreateIndex.cpp
        PARENT_SCOPE
        )

## mmseqs2 12-113e3+ds

=== debian/changelog ===
mmseqs2 (12-113e3+ds-3) unstable; urgency=high

  * Team upload.
  * debian/control: disable building on big-endian at the request of upstream.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 12 Feb 2021 15:31:20 +0100

mmseqs2 (12-113e3+ds-2) unstable; urgency=medium

  * Team upload.
  * Forwarded spelling patch upstream
  * debian/rules: Disable -march=native also on !x86, courtesy of Adrian Bunk

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 15 Nov 2020 19:29:37 +0100

mmseqs2 (12-113e3+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Freshen debian/copyright
  * debian/rules: Ensure all for-loops fail if there is an error
  * Build-depend on libsimde-dev 0.6.0-2 to get i386 patches from upstream
  * debian/patches/spelling: fix typos

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 02 Sep 2020 13:17:12 +0200

mmseqs2 (11-e1a1c+ds-4) unstable; urgency=medium

  * Team upload.
  * debian/patches/simde: Fix for i386 (Closes: #961101).
  * debian/rules: simplify the multi-build
  * debhelper-compat 13 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 31 Aug 2020 14:25:45 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12)
+Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch: cmake,
                     libgzstream-dev,
                     libzstd-dev,
@@ -17,7 +17,8 @@
 Rules-Requires-Root: no
 
 Package: mmseqs2
-Architecture: any
+Architecture: amd64 arm64 armel armhf i386 mips64el mipsel ppc64el alpha ia64 kfreebsd-amd64 kfreebsd-i386 riscv64 sh4 x32
+# only little-endian for now
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Built-Using: ${simde:Built-Using}

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

binprefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr/bin
libexecdir=$(prefix)/lib/$(DEB_SOURCE)

%:
	dh $@

AMD64_SIMD_LEVELS=avx2 avx sse4.1 ssse3 sse3
i386_SIMD_LEVELS=sse2 sse

override_dh_auto_configure-arch:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),export CXXFLAGS="$(CXXFLAGS) -m$(SIMD)" && export CFLAGS="$(CFLAGS) -m$(SIMD)" && \
	        dh_auto_configure --builddirectory build_$(SIMD) -- -DEXE_SUFFIX=-$(SIMD) -DVERSION_OVERRIDE=$(DEB_VERSION) -DNATIVE_ARCH=0 && ) true
	export CXXFLAGS="$(CXXFLAGS)" && export CFLAGS="$(CFLAGS)" && \
		dh_auto_configure --builddirectory build_plain -- -DEXE_SUFFIX=-plain -DVERSION_OVERRIDE=$(DEB_VERSION) -DNATIVE_ARCH=0
ifeq (i386,$(DEB_HOST_ARCH))
	$(foreach SIMD,$(i386_SIMD_LEVELS),export CXXFLAGS="$(CXXFLAGS) -m$(SIMD)" && export CFLAGS="$(CFLAGS) -m$(SIMD)" && \
	        dh_auto_configure --builddirectory build_$(SIMD) -- -DEXE_SUFFIX=-$(SIMD) -DVERSION_OVERRIDE=$(DEB_VERSION) -DNATIVE_ARCH=0 && ) true
endif
else
	dh_auto_configure -- -DVERSION_OVERRIDE=$(DEB_VERSION) -DNATIVE_ARCH=0
endif

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	mkdir -p $(binprefix)
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_build --builddirectory build_$(SIMD) && ) true
ifeq (i386,$(DEB_HOST_ARCH))
	$(foreach SIMD,$(i386_SIMD_LEVELS),dh_auto_build --builddirectory build_$(SIMD) && ) true
endif
else
	dh_auto_build
endif

override_dh_auto_build-indep:

override_dh_auto_install-arch:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	dh_install -pmmseqs2 debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_install --builddirectory build_$(SIMD) && ) true
ifeq (i386,$(DEB_HOST_ARCH))
	$(foreach SIMD,$(i386_SIMD_LEVELS),dh_auto_install --builddirectory build_$(SIMD) && ) true
endif
	dh_install -pmmseqs2 usr/bin/mmseqs-* usr/bin/
	set -e && cd $(binprefix) \
		&& for prog in mmseqs ; do \
		ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else
	dh_auto_install
	dh_install -pmmseqs2 usr/bin/mmseqs usr/bin/
endif

override_dh_auto_install-indep:

override_dh_auto_clean:
	dh_auto_clean
	rm -Rf build-*

override_dh_install-arch:
	dh_install --arch
	mkdir -p debian/mmseqs2/usr/lib/mmseqs2/test
	cp src/test/*.index debian/mmseqs2/usr/lib/mmseqs2/test/
	cp src/test/dataGap debian/mmseqs2/usr/lib/mmseqs2/test/
	cp src/test/dataLinear debian/mmseqs2/usr/lib/mmseqs2/test/
	#cp -r obj-$(DEB_HOST_MULTIARCH)/src/test debian/mmseqs2/usr/lib/mmseqs2/

	# We also remove unneeded files & folders like CMake
	rm -rf debian/mmseqs2/usr/lib/mmseqs2/test/CMakeFiles \
		debian/mmseqs2/usr/lib/mmseqs2/test/*.cmake \
		debian/mmseqs2/usr/lib/mmseqs2/test/Makefile

override_dh_install-indep:
	dh_install --indep

	# We also remove unneeded files & folders like CMake
	rm -rf debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/*.lib \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiag.out \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiagTargetCov.out

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/watch ===
version=4
opts=\
repacksuffix=+ds,dversionmangle=auto,\
repack,compression=xz \
https://github.com/soedinglab/MMseqs2/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@
